
#ifndef FastMallocMonitor_h
#define FastMallocMonitor_h


namespace WTF
{

struct FastMallocInfo
{
	FastMallocInfo()
	: allocatedBytes(0)
	, freePageBytes(0)
    , freeListBytes(0)
    , metaDataBytes(0)
    , peakAllocatedBytes(0)
    , shrinkedPages(0)
    , largestFreeChunk(0)
	{
	}

    size_t allocatedBytes;
    size_t freePageBytes;
    size_t freeListBytes;
    size_t metaDataBytes;
    size_t peakAllocatedBytes;
    size_t shrinkedPages;
    size_t largestFreeChunk;
};

FastMallocInfo fastMallocInfo();

typedef bool (*oomFuncPtr)(int askBytes, bool crashOnFailure, int iteration);

typedef int (*FastMallocLog)(const char * format, ... );

void setFastMallocCap(int capSizeKb, WTF::oomFuncPtr failedHandler, WTF::oomFuncPtr reportHandler, bool debugOn, bool enforce, bool backgroundScavenge, WTF::FastMallocLog log);

void addMemMap(void *ptr, int size);

class MonitorMallocFailedPreventer {
public:
	MonitorMallocFailedPreventer();
    ~MonitorMallocFailedPreventer();

    bool lowMemory() const { return m_lowMemory; }

    void setLowMemory() { m_lowMemory = true; }

private:
    bool m_lowMemory;
};

}

using WTF::MonitorMallocFailedPreventer;

#endif /*FastMallocMonitor_h*/
