#ifndef __WEBSOCKETCLIENT_H__
#define __WEBSOCKETCLIENT_H__

#if ENABLE(WEB_SOCKETS)

#include <wtf/Forward.h>
#include <wtf/PassOwnPtr.h>
#include <wtf/Vector.h>
#include <wtf/text/WTFString.h>

namespace WebCore {

    class WebSocketClient {
    public:
        virtual ~WebSocketClient() { }
        virtual void didCreate() = 0;
        virtual void didDestroy() = 0;
        virtual void didConnect(const String& subprotocol, const String& extensions) = 0;
        virtual void didReceiveMessage(const String&) = 0;
        virtual void didReceiveBinaryData(PassOwnPtr<Vector<char> >) = 0;
        virtual void didStartClosingHandshake() = 0;

        virtual void didClose(unsigned long /* unhandledBufferedAmount */, bool isClosingHandshakeCompleted, unsigned short /* code */, const String& /* reason */) = 0;
        virtual void didReceivePong(PassOwnPtr<Vector<char> >) = 0;
        virtual void didReceivePing(PassOwnPtr<Vector<char> >) = 0;
    protected:
        WebSocketClient() { }
    };

} // namespace WebCore

using WebCore::WebSocketClient;

#endif // ENABLE(WEB_SOCKETS)


#endif // __WEBSOCKETCLIENT_H__
