/*
 *  Copyright (c) 2015, Canon Inc. All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1.  Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *  2.  Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *  3.  Neither the name of Canon Inc. nor the names of
 *      its contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *  THIS SOFTWARE IS PROVIDED BY CANON INC. AND ITS CONTRIBUTORS "AS IS" AND ANY
 *  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *  DISCLAIMED. IN NO EVENT SHALL CANON INC. AND ITS CONTRIBUTORS BE LIABLE FOR
 *  ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"

#include "JSDOMGlobalObject.h"

#if ENABLE(FETCH_API)
#include "DOMWindowBuiltins.cpp"
#include "FetchHeadersBuiltins.cpp"
#include "FetchInternalsBuiltins.cpp"
#include "FetchRequestBuiltins.cpp"
#include "FetchResponseBuiltins.cpp"
#include "WorkerGlobalScopeBuiltins.cpp"
#endif

#if ENABLE(MEDIA_STREAM) && 0
#include "MediaDevicesBuiltins.cpp"
#endif

#if ENABLE(STREAMS_API)
#include "ByteLengthQueuingStrategyBuiltins.cpp"
#include "CountQueuingStrategyBuiltins.cpp"
#include "ReadableStreamBuiltins.cpp"
#include "ReadableStreamDefaultControllerBuiltins.cpp"
#include "ReadableStreamDefaultReaderBuiltins.cpp"
#include "ReadableStreamInternalsBuiltins.cpp"
#include "StreamInternalsBuiltins.cpp"
#include "WritableStreamBuiltins.cpp"
#include "WritableStreamInternalsBuiltins.cpp"
#endif
