
#include "config.h"
#include "NetTVTokenizer.h"
#include "NetTVDocument.h"


namespace WebCore {

NetTVTokenizer::NetTVTokenizer(NetTVDocument* doc)
: DocumentParser(doc)
, m_doc(doc)
, m_finishCalled(false)
{
}


NetTVTokenizer::~NetTVTokenizer()
{

}

void NetTVTokenizer::appendBytes(DocumentWriter*, const char* bytes, size_t length)
{	
	if(length > 0)
		static_cast<NetTVDocument*>(m_doc)->getBuffer().append(bytes, length);
}

void NetTVTokenizer::finish()
{
	m_finishCalled = true;
	
	static_cast<NetTVDocument*>(m_doc)->setOnloadFinished();
	
	m_doc->finishedParsing();
}

}
