
#ifndef NetTVTokenizer_h
#define NetTVTokenizer_h

#include <wtf/PassRefPtr.h>
#include "DocumentParser.h"

namespace WebCore {

class SegmentedString;
class NetTVDocument;

class NetTVTokenizer : public DocumentParser {
public:

    static PassRefPtr<NetTVTokenizer> create(NetTVDocument* document)
    {
        return adoptRef(new NetTVTokenizer(document));
    }
    
    ~NetTVTokenizer();

    enum ErrorType { warning, nonFatal, fatal };

    // insert is used by document.write.
    virtual void insert(const SegmentedString&) { }

    // appendBytes and flush are used by DocumentWriter (the loader).
    virtual void appendBytes(DocumentWriter*, const char* bytes, size_t length);
    virtual void flush(DocumentWriter*) { }

    // FIXME: append() should be private, but DocumentWriter::replaceDocument
    // uses it for now.
    virtual void append(const SegmentedString&) { }

    virtual void finish();
    virtual bool finishWasCalled() { return m_finishCalled; }

private:
	NetTVTokenizer(NetTVDocument*);
	
private:
	NetTVDocument* m_doc;
    bool m_finishCalled;
};

} // namespace WebCore

#endif // XMLTokenizer_h
