
#include "config.h"
#include "ExportedMalloc.h"
#include "ExportedSymbols.h"
#include "ApplicationCacheStorage.h"
#include "Chrome.h"
#include "CSSValuePool.h"
#include "Document.h"
#include "Element.h"
#include "File.h"
#include "FloatRect.h"
#include "FloatQuad.h"
#include "LayoutRect.h"
#include "Frame.h"
#include "FrameLoader.h"
#include "FrameView.h"
#include "GCController.h"
#include "GradientImage.h"
#include "JSDOMWindow.h"
#include "JSElement.h"
#include "JSEventListener.h"
#include "JSLock.h"
#include "HTMLFrameOwnerElement.h"
#include "HTMLNames.h"
#include "HitTestResult.h"
#include "HTTPParsers.h"
#include "IconController.h"
#include "Node.h"
#include "Page.h"
#include "GroupSettings.h"
#include "PlatformString.h"
#include "QualifiedName.h"
#include "RenderLayer.h"
#include "RenderView.h"
#include "RenderWidget.h"
#include "PageGroup.h"
#include "ResourceLoader.h"
#include "ResourceLoadScheduler.h"
#include "TextEncoding.h"
#include "SecurityOrigin.h"
#include "StorageAreaSync.h"
#include "TextEncoding.h"
#include "BitmapImage.h"
#include "DatabaseTracker.h"
#if ENABLE(RMAI)
#include "MOMPlayer.h"
#include "JSMOMPlayer.h"
#include "MOM.h"
#include "PluginViewMOM.h"
#include "JSDOMGlobalObject.h"
#include "Document.h"
#include "GalioWaferCollection.h"
#endif
#include <wtf/text/StringView.h>

using namespace WebCore;

namespace WebCore
{
extern void clearCachedShadowBlurBuffer();
extern void clearPresentationAttributeCache();
extern void clearDefaultStyleFonts();
}

namespace WebCoreAPIs
{

DLL_PUBLIC const WebCore::HTMLQualifiedName& aTag()			{ return HTMLNames::aTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& appletTag()	{ return HTMLNames::appletTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& areaTag()		{ return HTMLNames::areaTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& bodyTag()		{ return HTMLNames::bodyTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& brTag() 		{ return HTMLNames::brTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& buttonTag()	{ return HTMLNames::buttonTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& canvasTag()	{ return HTMLNames::canvasTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& divTag() 		{ return HTMLNames::divTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& embedTag() 	{ return HTMLNames::embedTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& formTag()		{ return HTMLNames::formTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& frameTag() 	{ return HTMLNames::frameTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& htmlTag()		{ return HTMLNames::htmlTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& iframeTag() 	{ return HTMLNames::iframeTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& imgTag() 	    { return HTMLNames::imgTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& inputTag() 	{ return HTMLNames::inputTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& liTag() 		{ return HTMLNames::liTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& preTag() 		{ return HTMLNames::preTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& spanTag() 		{ return HTMLNames::spanTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& styleTag() 	{ return HTMLNames::styleTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& titleTag() 	{ return HTMLNames::titleTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& objectTag()	{ return HTMLNames::objectTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& pTag() 		{ return HTMLNames::pTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& paramTag() 	{ return HTMLNames::paramTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& scriptTag()	{ return HTMLNames::scriptTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& textareaTag()	{ return HTMLNames::textareaTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& ulTag()		{ return HTMLNames::ulTag; }
DLL_PUBLIC const WebCore::HTMLQualifiedName& videoTag()		{ return HTMLNames::videoTag; }

#if ENABLE(BML)
DLL_PUBLIC const WebCore::HTMLQualifiedName& beitemTag()	{ return HTMLNames::beitemTag; }
#endif

DLL_PUBLIC bool hasTagName(const WebCore::Node& node, const WebCore::HTMLQualifiedName& name)
{
	return node.hasTagName(name);	
}

DLL_PUBLIC bool hasTagName(const WebCore::Node* node, const WebCore::HTMLQualifiedName& name)
{
	return node->hasTagName(name);	
}

DLL_PUBLIC const WebCore::QualifiedName& dataAttr() 				{ return HTMLNames::dataAttr; }
DLL_PUBLIC const WebCore::QualifiedName& hrefAttr() 				{ return HTMLNames::hrefAttr; }
DLL_PUBLIC const WebCore::QualifiedName& idAttr() 					{ return HTMLNames::idAttr; }
DLL_PUBLIC const WebCore::QualifiedName& inputmodeAttr() 			{ return HTMLNames::inputmodeAttr; }
DLL_PUBLIC const WebCore::QualifiedName& nameAttr() 				{ return HTMLNames::nameAttr; }
DLL_PUBLIC const WebCore::QualifiedName& readonlyAttr() 			{ return HTMLNames::readonlyAttr; }
DLL_PUBLIC const WebCore::QualifiedName& styleAttr()  				{ return HTMLNames::styleAttr; }
DLL_PUBLIC const WebCore::QualifiedName& typeAttr()					{ return HTMLNames::typeAttr; }
DLL_PUBLIC const WebCore::QualifiedName& valueAttr() 				{ return HTMLNames::valueAttr; }

DLL_PUBLIC void jsGarbageCollectNow(bool noStackObjects, bool clearCache, bool shouldDeleteAllCodeBlocks, bool force)
{
	gcController().garbageCollectNow(noStackObjects, clearCache, shouldDeleteAllCodeBlocks, force);
}

DLL_PUBLIC WebCore::ScriptValue executeScript(WebCore::Frame* frame, const String& script, bool forceUserGesture)
{
	return frame->script()->executeScript(script, forceUserGesture);
}

DLL_PUBLIC WebCore::RenderWidget* find(const WebCore::Widget* widget)
{
	return RenderWidget::find(widget);
}

//copied from RenderLayer.cpp : r57482
DLL_PUBLIC void scrollRectToVisible(RenderLayer* const layer, const IntRect &rect)
{
	RenderObject* const renderer = layer->renderer();
    RenderLayer* parentLayer = 0;
    IntRect newRect = rect;

    // We may end up propagating a scroll event. It is important that we suspend events until
    // the end of the function since they could delete the layer or the layer's renderer().
    FrameView& frameView = renderer->view()->frameView();

    bool restrictedByLineClamp = false;
    if (renderer->parent()) {
        parentLayer = renderer->parent()->enclosingLayer();
        restrictedByLineClamp = !renderer->parent()->style()->lineClamp().isNone();
    }

    if (renderer->hasOverflowClip() && !restrictedByLineClamp) {
        // Don't scroll to reveal an overflow layer that is restricted by the -webkit-line-clamp property.
        // This will prevent us from revealing text hidden by the slider in Safari RSS.
        RenderBox* box = layer->renderBox();
        ASSERT(box);
        FloatPoint absPos = box->localToAbsolute();
        absPos.move(box->borderLeft(), box->borderTop());

        IntRect layerBounds = IntRect(absPos.x() + layer->scrollXOffset(), absPos.y() + layer->scrollYOffset(), box->clientWidth(), box->clientHeight());
        IntRect exposeRect = IntRect(rect.x() + layer->scrollXOffset(), rect.y() + layer->scrollYOffset(), rect.width(), rect.height());
        IntRect r = WebCore::enclosingIntRect(layer->getRectToExpose(layerBounds, exposeRect, ScrollAlignment::alignToEdgeIfNeeded, ScrollAlignment::alignToEdgeIfNeeded));

        int xOffset = r.x() - absPos.x();
        int yOffset = r.y() - absPos.y();
        // Adjust offsets if they're outside of the allowable range.
        xOffset = max(0, std::min(layer->scrollWidth() - layerBounds.width(), xOffset));
        yOffset = max(0, std::min(layer->scrollHeight() - layerBounds.height(), yOffset));

        if (xOffset != layer->scrollXOffset() || yOffset != layer->scrollYOffset()) {
            int diffX = layer->scrollXOffset();
            int diffY = layer->scrollYOffset();

            layer->scrollToOffset(IntSize(xOffset, yOffset));

            diffX = layer->scrollXOffset() - diffX;
            diffY = layer->scrollYOffset() - diffY;

            newRect.setX(rect.x() - diffX);
            newRect.setY(rect.y() - diffY);
        }
    }
    else if (!parentLayer && renderer->isBox() && layer->renderBox()->canBeProgramaticallyScrolled()){
		if (renderer->document() && renderer->document()->ownerElement() && renderer->document()->ownerElement()->renderer()) {
			IntRect viewRect = frameView.visibleContentRect();

			IntRect r = WebCore::enclosingIntRect(layer->getRectToExpose(viewRect, rect, ScrollAlignment::alignToEdgeIfNeeded, ScrollAlignment::alignToEdgeIfNeeded));

			int xOffset = r.x();
			int yOffset = r.y();
			// Adjust offsets if they're outside of the allowable range.
			xOffset = max(0, std::min(frameView.contentsWidth(), xOffset));
			yOffset = max(0, std::min(frameView.contentsHeight(), yOffset));

			frameView.setScrollPosition(IntPoint(xOffset, yOffset));

			parentLayer = renderer->document()->ownerElement()->renderer()->enclosingLayer();

			newRect.setX(rect.x() - frameView.scrollX() + frameView.x());
			newRect.setY(rect.y() - frameView.scrollY() + frameView.y());
		}
		else {
			IntRect viewRect = frameView.visibleContentRect(true);

			IntRect r = WebCore::enclosingIntRect(layer->getRectToExpose(viewRect, rect, ScrollAlignment::alignToEdgeIfNeeded, ScrollAlignment::alignToEdgeIfNeeded));

			// This is the outermost view of a web page, so after scrolling this view we
			// scroll its container by calling Page::scrollRectIntoView.
			// This only has an effect on the Mac platform in applications
			// that put web views into scrolling containers, such as Mac OS X Mail.
			// The canAutoscroll function in EventHandler also knows about this.
			if (Frame* frame = frameView.frame()) {
				if (Page* page = frame->page())
					page->chrome()->scrollRectIntoView(rect);
			}
		}
    }

    if(parentLayer){
    	scrollRectToVisible(parentLayer, newRect);
    }
}

DLL_PUBLIC Color colorFromPremultipliedARGB(unsigned pixelColor)
{
	return WebCore::colorFromPremultipliedARGB(pixelColor);
}

DLL_PUBLIC unsigned premultipliedARGBFromColor(const Color& color)
{
	return WebCore::premultipliedARGBFromColor(color);
}

DLL_PUBLIC WebCore::FrameView* frameView(const WebCore::Node* node)
{
	return node->document() ? node->document()->view() : 0;
}

DLL_PUBLIC void setShouldTrackVisitedLinks(bool shouldTrack)
{
	PageGroup::setShouldTrackVisitedLinks(shouldTrack);
}

DLL_PUBLIC void addSubResourceLoad(WebCore::ResourceLoader* resourceLoader)
{
	resourceLoadScheduler()->scheduleLoad(resourceLoader);
}

DLL_PUBLIC WebCore::KURL iconURL(WebCore::Frame* frame)
{
	return frame->loader()->icon()->url();
}

DLL_PUBLIC bool isLiveLink(const WebCore::HitTestResult& hit)
{
	return hit.isLiveLink();
}

DLL_PUBLIC WebCore::KURL absoluteLinkURL(const WebCore::HitTestResult& hit)
{
	return hit.absoluteLinkURL();
}

DLL_PUBLIC bool protocolIsJavaScript(const WebCore::KURL& url)
{
	return WebCore::protocolIsJavaScript(url.string());
}

DLL_PUBLIC String decodeURLEscapeSequences(const String& string)
{
	return WebCore::decodeURLEscapeSequences(string);
}

DLL_PUBLIC String decodeURLEscapeSequences(const String& string, const String& encoding)
{
	return WebCore::decodeURLEscapeSequences(string, TextEncoding(encoding));
}

DLL_PUBLIC WebCore::Color makeColor(int r, int g, int b, int a)
{
	return WebCore::Color(r, g, b, a);
}

DLL_PUBLIC String navProperty(WebCore::StyledElement* e, WebCore::StyledElement::ENavProperty index)
{
	return e->navProperty(index);
}

DLL_PUBLIC Element* getElementById(WebCore::Document* doc, const String& id)
{
	return doc->getElementById(id);
}

DLL_PUBLIC void dispatchSimulatedClick(WebCore::Element* element, WebCore::Event* underlyingEvent, bool sendMouseEvents, bool showPressedLook)
{
	element->dispatchSimulatedClick(underlyingEvent, sendMouseEvents ? SendMouseUpDownEvents : SendNoEvents, showPressedLook ? ShowPressedLook : DoNotShowPressedLook);
}

DLL_PUBLIC String filenameFromHTTPContentDisposition(const String& value)
{
	return WebCore::filenameFromHTTPContentDisposition(value);
}

DLL_PUBLIC String extractMIMETypeFromMediaType(const String& mediaType)
{
	return WebCore::extractMIMETypeFromMediaType(mediaType);
}

DLL_PUBLIC String extractCharsetFromMediaType(const String& mediaType)
{
	return WebCore::extractCharsetFromMediaType(mediaType);
}

DLL_PUBLIC WebCore::IntRect enclosingIntRect(const WebCore::FloatRect& rect)
{
	return WebCore::enclosingIntRect(rect);
}

DLL_PUBLIC WebCore::IntRect enclosingIntRect(const WebCore::LayoutRect& rect)
{
	return WebCore::enclosingIntRect(rect);
}

DLL_PUBLIC WebCore::IntRect enclosingBoundingBox(const WebCore::FloatQuad& quad)
{
	return quad.enclosingBoundingBox();
}

DLL_PUBLIC PassRefPtr<WebCore::SharedBuffer> utf8Buffer(const String& string)
{
	return WebCore::utf8Buffer(string);
}

DLL_PUBLIC bool hasEventListeners(WebCore::EventTarget* target, const AtomicString& eventType)
{
	return target->hasEventListeners(eventType);
}

DLL_PUBLIC PassRefPtr<WebCore::File> createFile(const String& filename)
{
	return WebCore::File::create(filename);
}

DLL_PUBLIC PassRefPtr<WebCore::Document> createDocument(WebCore::Frame* frame, const WebCore::KURL& url)
{
	return WebCore::Document::create(frame, url);
}

DLL_PUBLIC PassRefPtr<WebCore::SecurityOrigin> createSecurityOrigin(const WebCore::KURL& kurl)
{
	return WebCore::SecurityOrigin::create(kurl);
}

DLL_PUBLIC void addJSEventListener(WebCore::JSElement* thisJSElement, JSC::ExecState* exec, const String& eventName, JSC::JSValue value)
{
	if (value.isObject())
		thisJSElement->wrapped().addEventListener(eventName, JSEventListener::create(asObject(value), thisJSElement, false, currentWorld(exec)), false);
}

DLL_PUBLIC void removeJSEventListener(WebCore::JSElement* thisJSElement, JSC::ExecState* exec, const String& eventName, JSC::JSValue value)
{
	if (value.isObject())
		thisJSElement->wrapped().removeEventListener(eventName, JSEventListener::create(asObject(value), thisJSElement, false, currentWorld(exec)).get(), false);
}

DLL_PUBLIC void clearJSEventListeners(WebCore::JSElement* thisJSElement, JSC::ExecState* exec, const String& eventName)
{
	Element& element = static_cast<Element&>(thisJSElement->wrapped());

	EventListenerVector listeners = element.getEventListeners(eventName);
	for(int i = 0; i < listeners.size(); ++i) {
		auto& eventListener = listeners[i];
		element.removeEventListener(eventName, &eventListener->listener(), eventListener->useCapture());
	}
}

DLL_PUBLIC void dispatchJSEvent(WebCore::Element* target, const String& eventName, const JSC::MarkedArgumentBuffer& args)
{
	if(!target || !target->document() || !target->document()->frame())
		return;

	WebCore::JSDOMWindow* globalObject = target->document()->frame()->script()->globalObject(WebCore::mainThreadNormalWorld());

	if(!globalObject)
		return;

	JSC::ExecState* exec = globalObject->globalExec();

	WebCore::EventListenerVector listeners = target->getEventListeners(eventName);
	for(int i = 0; i < listeners.size(); ++i){
		if(const JSEventListener* jsEventListener = JSEventListener::cast(&listeners[i]->listener())){
			JSC::CallData callData;
			JSC::CallType callType;

			JSC::JSValue jsFunction = jsEventListener->jsFunction(target->document());

			callType = JSC::getCallData(jsFunction, callData);

			if (callType != JSC::CallType::None)
				JSC::call(exec, jsFunction, callType, callData, JSC::jsUndefined(), args);
		}
	}

	exec->clearException();
}

DLL_PUBLIC CString encode(const char* encodingName, StringView characters, WebCore::UnencodableHandling handling)
{
	return TextEncoding(encodingName).encode(characters, handling);
}

DLL_PUBLIC void clearAcceleratedSurfaceCache()
{
	WebCore::clearCachedShadowBlurBuffer();
	WebCore::clearCachedGeneratorGeneratedImageBuffers();

	WebCore::BitmapImage::destroyAcceleratedSurfaces();
}

DLL_PUBLIC String externalRepresentation(WebCore::Frame* frame, WebCore::RenderAsTextBehavior behavior)
{
	return WebCore::externalRepresentation(frame, behavior);
}

DLL_PUBLIC void setIndexedDBDatabasePath(WebCore::Page* page, const String& path)
{
	page->group().groupSettings()->setIndexedDBDatabasePath(path);
}

DLL_PUBLIC void webdatabaseSetQuota(const String& path, const char* domain, unsigned long long quota)
{
#if ENABLE(SQL_DATABASE)
	RefPtr<SecurityOrigin> origin = SecurityOrigin::createFromString(domain);
	DatabaseTracker& tracker = DatabaseTracker::tracker();
	tracker.setDatabaseDirectoryPath(path);
	tracker.setQuota(origin.get(), quota);
#endif
}

DLL_PUBLIC void scheduleRedirect(WebCore::Frame* frame, double delay, const String& url)
{
	frame->navigationScheduler()->scheduleRedirect(delay, url);
}

#if ENABLE(RMAI)
DLL_PUBLIC PassRefPtr<WebCore::MOMPlayer> createMOMPlayer(WebCore::ScriptExecutionContext* context)
{
	return WebCore::MOMPlayer::create(context);
}

DLL_PUBLIC JSC::JSValue getJSValueFromMOMPlayer(JSC::ExecState* exec, WebCore::Element* element, WebCore::MOMPlayer* player)
{
    WebCore::JSDOMGlobalObject* globalObject = toJSDOMGlobalObject(element->document(), exec);
	return toJS(exec, globalObject, player);
}

DLL_PUBLIC void initMOM()
{
	MOM::init();
}

DLL_PUBLIC void loadApplicationTree(WebCore::Frame* frame)
{
    GalioWaferCollection::instance()->createApplicationTree(frame);
}

DLL_PUBLIC PassRefPtr<WebCore::Widget> createPluginViewMOM(WebCore::Frame* parentFrame, const WebCore::IntSize& pluginSize, WebCore::Element* element, const WebCore::KURL& url, const WTF::Vector<WTF::String>& paramNames, const WTF::Vector<WTF::String>& paramValues, const WTF::String& mimeType, bool loadManually)
{
    return PluginViewMOM::create(parentFrame, pluginSize, element, url, paramNames, paramValues, mimeType, loadManually);
}

DLL_PUBLIC void setPluginViewMOMPlayer(PluginViewMOM* pluginViewMOM, JSC::JSValue value)
{
    pluginViewMOM->setPlayer(toMOMPlayer(value));
}
    
DLL_PUBLIC void setPluginViewActive(PluginViewMOM* pluginViewMOM, JSC::JSValue value)
{
    pluginViewMOM->setActive(value.isBoolean() && value.asBoolean());
}

DLL_PUBLIC bool handleKeyEvent(const PlatformKeyboardEvent& kevt, Frame* frame)
{
    return GalioWaferCollection::instance()->handleKeyEvent(kevt, frame);
}
#endif // ENABLE(RMAI)

DLL_PUBLIC void closeAllDatabases()
{
	WebCore::cacheStorageUntrusted().closeDatabase();
	WebCore::cacheStorageTrusted().closeDatabase();

	WebCore::StorageAreaSync::closeAllDatabases();
}

DLL_PUBLIC void handleMemoryPressure()
{
	WebCore::drainCSSValuePool();
	WebCore::clearPresentationAttributeCache();
	WebCore::clearDefaultStyleFonts();

	WebCore::Page::jettisonSelectorQueryCacheInAllDocuments();
	WebCore::Page::jettisonStyleResolversInAllDocuments();

	{
		JSC::JSGlobalData* vm = WebCore::JSDOMWindow::commonJSGlobalData();
		JSC::JSLockHolder lock(vm);
		vm->stringCache.clear();
		vm->heap.deleteAllCodeBlocks(false);
		JSC::gcExecutableAllocators(true);
		vm->clearSourceProviderCaches();
	}
}

DLL_PUBLIC void invalidateDOMCookieCacheInAllDocuments()
{
	WebCore::Page::invalidateDOMCookieCacheInAllDocuments();
}

} // namespace WebCoreAPIs

DLL_PUBLIC void* webkit_malloc(size_t n)
{
	return fastMalloc(n);
}

DLL_PUBLIC void* webkit_calloc(size_t n, size_t elem_size)
{
	return fastCalloc(n, elem_size);
}

DLL_PUBLIC char* webkit_strdup(const char* src)
{
	return fastStrDup(src);
}

DLL_PUBLIC void* webkit_realloc(void *ptr, size_t size)
{
	return fastRealloc(ptr, size);
}

DLL_PUBLIC void webkit_free(void *p)
{
	fastFree(p);
}

