/*
#    (c)2010-2011 Broadcom Corporation
#
# This program is the proprietary software of Broadcom Corporation and/or its licensors,
# and may only be used, duplicated, modified or distributed pursuant to the terms and
# conditions of a separate, written license agreement executed between you and Broadcom
# (an "Authorized License").  Except as set forth in an Authorized License, Broadcom grants
# no license (express or implied), right to use, or waiver of any kind with respect to the
# Software, and Broadcom expressly reserves all rights in and to the Software and all
# intellectual property rights therein.  IF YOU HAVE NO AUTHORIZED LICENSE, THEN YOU
# HAVE NO RIGHT TO USE THIS SOFTWARE IN ANY WAY, AND SHOULD IMMEDIATELY
# NOTIFY BROADCOM AND DISCONTINUE ALL USE OF THE SOFTWARE.
#
# Except as expressly set forth in the Authorized License,
#
# 1.     This program, including its structure, sequence and organization, constitutes the valuable trade
# secrets of Broadcom, and you shall use all reasonable efforts to protect the confidentiality thereof,
# and to use this information only in connection with your use of Broadcom integrated circuit products.
#
# 2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS PROVIDED "AS IS"
# AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES, REPRESENTATIONS OR
# WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY, OR OTHERWISE, WITH RESPECT TO
# THE SOFTWARE.  BROADCOM SPECIFICALLY DISCLAIMS ANY AND ALL IMPLIED WARRANTIES
# OF TITLE, MERCHANTABILITY, NONINFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE,
# LACK OF VIRUSES, ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET POSSESSION
# OR CORRESPONDENCE TO DESCRIPTION. YOU ASSUME THE ENTIRE RISK ARISING OUT OF
# USE OR PERFORMANCE OF THE SOFTWARE.
#
# 3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL BROADCOM OR ITS
# LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL, INCIDENTAL, SPECIAL, INDIRECT, OR
# EXEMPLARY DAMAGES WHATSOEVER ARISING OUT OF OR IN ANY WAY RELATING TO YOUR
# USE OF OR INABILITY TO USE THE SOFTWARE EVEN IF BROADCOM HAS BEEN ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN EXCESS OF THE AMOUNT
# ACTUALLY PAID FOR THE SOFTWARE ITSELF OR U.S. $1, WHICHEVER IS GREATER. THESE
# LIMITATIONS SHALL APPLY NOTWITHSTANDING ANY FAILURE OF ESSENTIAL PURPOSE OF
# ANY LIMITED REMEDY.
 *
 * $brcm_Workfile: MediaPlayerPrivateVariables.h $
 * $brcm_Revision: 4 $
 * $brcm_Date: 8/17/11 9:36a $
 * 
 * Module Description:
 * 
 * Revision History:
 * 
 * $brcm_Log: /AppLibs/broadcom/webbrowser/aal/media/BMEDIA/MediaPlayerPrivateVariables.h $
 * 
 * 4   8/17/11 9:36a dliu
 * SW7425-1077: Add support for FCC
 * 
 * 3   1/18/11 5:29p dliu
 * SW7420-1259: Make the z-order dependent on decoder index
 * 
 * 2   12/1/10 3:16p dliu
 * SW7420-1259: Change bmedia to be stream based to support pip and
 *  mosaics
*/

#ifndef MediaPlayerPrivateVariables_h
#define MediaPlayerPrivateVariables_h

#if ENABLE(VIDEO)

#include "BCMediaPlayerPrivateMangareva.h"

namespace WebCore {

	class MediaPlayerPrivateVariables
	{
		friend class MediaPlayerPrivateBC;

	public:
		MediaPlayerPrivateVariables();

		int m_id;
		static int s_hostID;
		bool m_isEndReached;
		KURL m_url;
		bool m_urlChanged;
		IntRect m_viewRect;
		bool m_gainedFocus;
		int m_initialSeekTime;
		static void* s_handle;
		static uint8_t s_handleCount;
		static bool s_playerInUse;
		static MediaPlayerPrivateBC* s_currentPlayer;
                int s_streamIndex;
		int s_decoderIndex;
		bool m_isPrime;
		int s_primeIndex;

        int m_hostID;
        void* m_handle;
    bool m_playerInUse;
	};

}

#endif // ENABLE(VIDEO)
#endif // MediaPlayerPrivateVariables_h
