/** @file GalioConfiguration.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef GalioConfiguration_h
#define GalioConfiguration_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "ExceptionCode.h"

namespace WebCore {

class GalioConfigurationItem;
class GalioConfigurationComponent;
class ScriptExecutionContext;

class GalioConfiguration : public RefCounted<GalioConfiguration> {
public:

    static PassRefPtr<GalioConfiguration> create();

    void persist(ExceptionCode& ec );
    void persist( int delayInMilliSecs, ExceptionCode& ec );
    PassRefPtr<GalioConfigurationItem> get( const String & name );
    void set( const String & name, const String & value, ExceptionCode& ec );
    PassRefPtr<GalioConfigurationComponent> createComponent( ScriptExecutionContext* context, const String & name, ExceptionCode& ec );
    PassRefPtr<GalioConfigurationComponent> getComponent( ScriptExecutionContext* context, const String & name, ExceptionCode& ec );

protected:
    GalioConfiguration();
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // GalioConfiguration_h
