/** @file GalioConfigurationEvent.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef GalioConfigurationEvent_h
#define GalioConfigurationEvent_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "Event.h"
#include "GalioConfigurationItem.h"

namespace WebCore {

class GalioConfigurationEvent : public Event {
public:
    static PassRefPtr<GalioConfigurationEvent> create(String name, PassRefPtr<GalioConfigurationItem> value) {
        return adoptRef(new GalioConfigurationEvent(name, value));
    }

    bool isGalioConfigurationEvent() const { return true; }

    String item() const { return m_item; }
    GalioConfigurationItem* value() const { return m_value.get(); }

protected:
    GalioConfigurationEvent(String name, PassRefPtr<GalioConfigurationItem> value);

private:
    String m_item;
    RefPtr<GalioConfigurationItem> m_value;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // GalioConfigurationEvent_h
