/** @file GalioUtility.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef GalioUtility_h
#define GalioUtility_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

namespace WebCore {

class Node;

class GalioUtility : public RefCounted<GalioUtility> {
public:

    static PassRefPtr<GalioUtility> create();

    void setScreenSize( int width, int height );
    String formatTime( const String & format, int time);
    String formatTime( const String & format, int time, bool formatAsUTC );
    void setTimeOffset( int offset );
    void setStartTime( const String & startTime );
    int keyQueueFill();
    int keyQueuePeekCode( int index );
    int keyQueuePeekType( int index );
    void keyQueueConsume( int count );
    void setKeyRepeat( int initialInterval, int initialDelay, int finalInterval );
    void flushRedraws( Node* document, bool updateImmediately );
    void systemReboot();
    void systemReboot( const String & message );
    String abbreviateText( Node* nodeContext, const String & content, int maxWidth);
    String abbreviateText( Node* nodeContext, const String & content, int maxWidth, const String & ellipsis );

protected:
    GalioUtility();
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // GalioUtility_h
