/** @file JSGalioConfigurationCustom.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMException.h"
#include "GalioConfiguration.h"
#include "JSGalioConfiguration.h"
#include "GalioConfigurationComponent.h"
#include "JSGalioConfigurationComponent.h"

using namespace JSC;

namespace WebCore {
    
JSValue JSGalioConfiguration::createComponent(ExecState* exec)
{
    GalioConfiguration& imp = static_cast<GalioConfiguration&>(wrapped());
    ExceptionCode ec = 0;
    String name = WebCore::valueToStringWithNullCheck(exec, exec->argument(0));
    if (exec->hadException())
        return jsUndefined();

    ScriptExecutionContext* context = globalObject()->scriptExecutionContext();
    if(!context)
        return jsUndefined();

    JSC::JSValue result = toJS(exec, globalObject(), WTF::getPtr(imp.createComponent(context, name, ec)));
    setDOMException(exec, ec);
    return result;
}

JSValue JSGalioConfiguration::getComponent(ExecState* exec)
{
    GalioConfiguration& imp = static_cast<GalioConfiguration&>(wrapped());
    ExceptionCode ec = 0;
    String name = WebCore::valueToStringWithNullCheck(exec, exec->argument(0));
    if (exec->hadException())
        return jsUndefined();

    ScriptExecutionContext* context = globalObject()->scriptExecutionContext();
    if(!context)
        return jsUndefined();

    JSC::JSValue result = toJS(exec, globalObject(), WTF::getPtr(imp.getComponent(context, name, ec)));
    setDOMException(exec, ec);
    return result;
}

    
} // namespace WebCore

#endif // ENABLE(RMAI)
