/** @file JSMOMContentPagedListCustom.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMException.h"
#include "MOMContentPagedList.h"

#include "JSMOMContentPagedList.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_content_paged_list.h"
}

using namespace JSC;

namespace WebCore {
    
JSValue JSMOMContentPagedList::totalSize(ExecState* exec) const
{
    MOMContentPagedList& imp = static_cast<MOMContentPagedList&>(wrapped());
    size_t n = mom_content_paged_list_total_length( imp.itemAsContentPagedList() );
    return n == mom_content_paged_list_size_INVALID ? jsUndefined() : jsNumber(n);
}
    
JSValue JSMOMContentPagedList::currentPage(ExecState* exec) const
{
    MOMContentPagedList& imp = static_cast<MOMContentPagedList&>(wrapped());
    size_t n = mom_content_paged_list_current_page( imp.itemAsContentPagedList() );
    return n == mom_content_paged_list_size_INVALID ? jsUndefined() : jsNumber(n);
}
    
JSValue JSMOMContentPagedList::pageSize(ExecState* exec) const
{
    MOMContentPagedList& imp = static_cast<MOMContentPagedList&>(wrapped());
    size_t n = mom_content_paged_list_page_size( imp.itemAsContentPagedList() );
    return n == mom_content_paged_list_size_INVALID ? jsUndefined() : jsNumber(n);
}

} // namespace WebCore

#endif // ENABLE(RMAI)
