/** @file JSMOMDeviceCustom.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMDevice.h"
#include "JSMOMDevice.h"
#include "JSMOMRecorder.h"
#include "JSMOMSource.h"

using namespace JSC;

namespace WebCore {

JSValue toJS(ExecState* exec, JSDOMGlobalObject* globalObject, MOMDevice* device)
{
    if (!device)
        return jsNull();

    JSObject* wrapper = getCachedWrapper(globalObject->world(), device);
    if (wrapper)
        return wrapper;

    switch (mom_driver_type(device->driver()))
    {
    case MDA_SOURCE:
        wrapper = CREATE_DOM_WRAPPER(globalObject, MOMSource, device);
        break;
    case MDA_RECORDER:
        wrapper = CREATE_DOM_WRAPPER(globalObject, MOMRecorder, device);
        break;
    default:
         break;
    }
    return wrapper;
}

} // namespace WebCore

#endif // ENABLE(RMAI)
