/** @file JSMOMNetworkInterfaceCustom.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMException.h"
#include "MOMNetworkInterface.h"

#include "UtilsMOM.h"

#include "JSMOMNetworkInterface.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_networkinterface.h"
}

using namespace JSC;

namespace WebCore {
    
JSValue runTest(ExecState* exec, MOMNetworkInterface* nif, MDAConnectivityTestReason reason)
{
    String addr = WebCore::valueToStringWithNullCheck(exec, exec->argument(0));

    layers_string laddr = UtilsMOM::LayersStringFromString(addr);

    int32_t id;
    MDAStatus status = mom_networkinterface_test( reason, nif->index(), laddr, &id );
    layers_string_dispose(laddr);

    if ( status != MDA_OK)
        return jsUndefined();

    return jsNumber(id);
}
    
JSValue JSMOMNetworkInterface::pingTest(ExecState* exec)
{
    return runTest(exec, static_cast<MOMNetworkInterface*>(&wrapped()), e_momnetworkinterface_ping);
}

JSValue JSMOMNetworkInterface::urlTest(ExecState* exec)
{
    return runTest(exec, static_cast<MOMNetworkInterface*>(&wrapped()), e_momnetworkinterface_url);
}
    
} // namespace WebCore

#endif // ENABLE(RMAI)
