/** @file JSMOMPackageManagerCustom.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMException.h"
#include "MOMPackageManager.h"
#include "MOMPackageList.h"

#include "UtilsMOM.h"

#include "JSMOMPackageManager.h"
#include "JSMOMPackageList.h"

extern "C" {
#include "layers.h"
}

using namespace JSC;

namespace WebCore {
    
JSValue JSMOMPackageManager::createFilteredList(ExecState* exec)
{
    MOMPackageManager& imp = static_cast<MOMPackageManager&>(wrapped());
    int argc = exec->argumentCount();

    int type = exec->argument(0).toInt32(exec);
    int signalled = -1;
    int stored = -1;
    int builtin = -1;
    int displayInMenu = -1;
    if (argc > 1)
        signalled = exec->argument(1).toBoolean(exec);
    if (argc > 2)
        stored = exec->argument(2).toBoolean(exec);
    if (argc > 3)
        builtin = exec->argument(3).toBoolean(exec);
    if (argc > 4)
        displayInMenu = exec->argument(4).toBoolean(exec);

    return toJS(exec, globalObject(), imp.createFilteredList(type, signalled, stored, builtin, displayInMenu));
}

} // namespace WebCore

#endif // ENABLE(RMAI)
