/** @file JSMOMRendererCustom.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMRenderer.h"
#include "JSMOMRenderer.h"
#include "MOMPlayer.h"
#include "JSMOMPlayer.h"

using namespace JSC;

namespace WebCore {

JSValue toJS(ExecState* exec, JSDOMGlobalObject* globalObject, MOMRenderer* rend)
{
    if (!rend)
        return jsNull();

    JSObject* wrapper = getCachedWrapper(globalObject->world(), rend);
    if (wrapper)
        return wrapper;

    if (rend->isPlayer())
        wrapper = CREATE_DOM_WRAPPER(globalObject, MOMPlayer, rend);
    else
        wrapper = CREATE_DOM_WRAPPER(globalObject, MOMRenderer, rend);

    return wrapper;
}

} // namespace WebCore

#endif // ENABLE(RMAI)
