/** @file JSMOMSourceCustom.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMException.h"
#include "MOMSource.h"

#include "JSMOMSource.h"

extern "C" {
#include "layers.h"
}

using namespace JSC;

namespace WebCore {
    
JSValue JSMOMSource::signalStrength(ExecState* exec) const
{
    MOMSource& imp = static_cast<MOMSource&>(wrapped());
    int strength = imp.intAttr(MDA_ATTR_SIGNAL_STRENGTH);
    if (strength != -1)
        return jsNumber(strength);
    return jsUndefined();
}

} // namespace WebCore

#endif // ENABLE(RMAI)
