/** @file MOMCable.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMCable_h
#define MOMCable_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

extern "C" {
#include "layers.h"
#include "cdf/mom_cable.h"
}

namespace WebCore {

class MOMCable : public RefCounted<MOMCable> {
public:

    static PassRefPtr<MOMCable> create();
    ~MOMCable();

    int startFrequencyMHz() const;
    void setStartFrequencyMHz(int startFrequencyMHz);

    int endFrequencyMHz() const;
    void setEndFrequencyMHz(int endFrequencyMHz);

    int channelBandwidthMHz() const;
    void setChannelBandwidthMHz(int channelBandwidthMHz);

    MOMCable* symbolRateMBd() const;
    int length() const;

protected:
    MOMCable();

private:
    mom_cable m_cable;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMCable_h
