/** @file MOMChannelList.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMChannelList_h
#define MOMChannelList_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>
#include "ExceptionCode.h"
#include "MOMContentList.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_channel_list.h"
}

namespace WebCore {

class MOMChannelList;
class MOMChannel;


class MOMChannelList : public MOMContentList {
public:
    static PassRefPtr<MOMChannelList> createAdopt(ScriptExecutionContext *context, mom_channel_list list);
    static PassRefPtr<MOMChannelList> create(ScriptExecutionContext *context, mom_channel_list list);
    static PassRefPtr<MOMChannelList> create(ScriptExecutionContext *context, ExceptionCode& ec);
    MOMChannelList(ScriptExecutionContext *context, mom_content_item item);

    void setLength(int length, ExceptionCode& ec);

    void append( MOMChannel* newItem, ExceptionCode& ec );
    void remove( MOMChannel* item, ExceptionCode& ec );
    PassRefPtr<MOMChannel> getChannel( int channelNumber, ExceptionCode& ec );
    void insertAt( int index, MOMChannel* item, ExceptionCode& ec );
    PassRefPtr<MOMChannel> getChannelByName( const String & name );
    void replace( MOMChannelList* newList, ExceptionCode& ec );

    ALWAYS_INLINE mom_channel_list itemAsChannelList() const { return (mom_channel_list)m_item; }
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMChannelList_h
