/** @file MOMChannelScanEvent.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMChannelScanEvent_h
#define MOMChannelScanEvent_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "MOMEvent.h"

namespace WebCore {

class MOMChannelScanEvent : public MOMEvent {
public:
    enum {
        START = 0,
        PROGRESS = 1,
        CHANNEL_FOUND = 2,
        TRANSPONDER_FOUND = 3,
        COMPLETE = 4,
        ABORTED = 5,
    };

    static PassRefPtr<MOMChannelScanEvent> create()
    {
        return adoptRef(new MOMChannelScanEvent);
    }

    int type() const { return getIntParam(mom_event_CHANNELSCAN_TYPE); }
    int progress() const { return getIntParam(mom_event_CHANNELSCAN_PROGRESS); }
    int frequency() const { return getIntParam(mom_event_CHANNELSCAN_FREQUENCY); }
    int signalStrength() const { return getIntParam(mom_event_CHANNELSCAN_SIGNALSTRENGTH); }
    int channel() const { return getIntParam(mom_event_CHANNELSCAN_CHANNEL); }
    int channelType() const { return getIntParam(mom_event_CHANNELSCAN_CHANNELTYPE); }
    int channelCount() const { return getIntParam(mom_event_CHANNELSCAN_CHANNELCOUNT); }
    int transponderCount() const { return getIntParam(mom_event_CHANNELSCAN_TRANSPONDERCOUNT); }
    int quality() const { return getIntParam(mom_event_CHANNELSCAN_QUALITY); }

    MOMChannelScanEvent(const mom_event_params* params, ScriptExecutionContext* context);
private:
    MOMChannelScanEvent();
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMChannelScanEvent_h
