/** @file MOMComponent.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMComponent_h
#define MOMComponent_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

extern "C" {
#include "layers.h"
#include "cdf/mom_component.h"
}

namespace WebCore {

class MOMComponent : public RefCounted<MOMComponent> {
public:
    enum {
        COMPONENT_TYPE_VIDEO = 1,
        COMPONENT_TYPE_AUDIO = 2,
        COMPONENT_TYPE_SUBTITLE = 3,
    };

    static PassRefPtr<MOMComponent> create(mom_component comp);
    ~MOMComponent();

    int type() const;
    int pid() const;
    String encoding() const;
    bool encrypted() const;
    String language() const;

    String getData();

    ALWAYS_INLINE mom_component component() const { return m_component; }

protected:
    MOMComponent(mom_component comp);

private:
    mom_component m_component;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMComponent_h
