/** @file MOMComponentCollection.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMComponentCollection.h"
#include "MOMComponent.h"

extern "C" {
#include "layers.h"
}

namespace WebCore {

PassRefPtr<MOMComponentCollection> MOMComponentCollection::create(mom_components comps)
{
    return adoptRef(new MOMComponentCollection(comps));
}

MOMComponentCollection::MOMComponentCollection(mom_components comps)
    : m_comps(comps)
{
}

MOMComponentCollection::~MOMComponentCollection()
{
    if (m_comps)
        mom_components_dispose(m_comps);
}

int MOMComponentCollection::length() const
{
    return m_comps ? mom_components_count(m_comps) : 0;
}

PassRefPtr<MOMComponent> MOMComponentCollection::item( int index )
{
    return MOMComponent::create(mom_components_get_component(m_comps, index));
}

} // namespace WebCore

#endif // ENABLE(RMAI)
