/** @file MOMComponentCollection.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMComponentCollection_h
#define MOMComponentCollection_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

extern "C" {
#include "layers.h"
#include "cdf/mom_component.h"
}

namespace WebCore {

class MOMComponent;

class MOMComponentCollection : public RefCounted<MOMComponentCollection> {
public:

    static PassRefPtr<MOMComponentCollection> create(mom_components comps);
    ~MOMComponentCollection();

    int length() const;

    PassRefPtr<MOMComponent> item( int index );

protected:
    MOMComponentCollection(mom_components comps);

private:
    mom_components m_comps;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMComponentCollection_h
