/** @file MOMComponentEvent.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMComponentEvent.h"

namespace WebCore {

MOMComponentEvent::MOMComponentEvent(const mom_event_params* params, ScriptExecutionContext*)
    : MOMEvent(AtomicString("MOM_Component"), params)
{
    ASSERT(params->arg_count == mom_event_COMPONENT_COUNT);

    setIntParam(mom_event_COMPONENT_REASON, params->args[mom_event_COMPONENT_REASON]);
    m_object = params->object ? MOMComponent::create(static_cast<mom_component>(params->object)) : nullptr;
}

MOMComponentEvent::MOMComponentEvent()
    : MOMEvent(AtomicString("MOM_Component"))
{
}

} // namespace WebCore

#endif // ENABLE(RMAI)
