/** @file MOMConfiguration.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMConfiguration_h
#define MOMConfiguration_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

namespace WebCore {

class MOMConfiguration : public RefCounted<MOMConfiguration> {
public:

    static PassRefPtr<MOMConfiguration> create();

    String preferredAudioLanguage() const;
    void setPreferredAudioLanguage(const String & preferredAudioLanguage);

    String preferredSubtitleLanguage() const;
    void setPreferredSubtitleLanguage(const String & preferredSubtitleLanguage);

    String screenLanguage() const;
    void setScreenLanguage(const String & screenLanguage);

    String countryId() const;
    void setCountryId(const String & countryId);

    int regionId() const;
    void setRegionId(int regionId);

    int dvrPolicy() const;
    void setDvrPolicy(int dvrPolicy);

    int dvrSaveEpisodes() const;
    void setDvrSaveEpisodes(int dvrSaveEpisodes);

    int dvrSaveDays() const;
    void setDvrSaveDays(int dvrSaveDays);

    int dvrStartPadding() const;
    void setDvrStartPadding(int dvrStartPadding);

    int dvrEndPadding() const;
    void setDvrEndPadding(int dvrEndPadding);

    int channelScanTime() const;
    void setChannelScanTime(int channelScanTime);

    void restoreDefaults();

protected:
    MOMConfiguration();
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMConfiguration_h
