/** @file MOMConnectionInfo.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMConnectionInfo.h"

namespace WebCore {

PassRefPtr<MOMConnectionInfo> MOMConnectionInfo::create(const MDAConnectionInfo& info)
{
    return adoptRef(new MOMConnectionInfo(info));
}

MOMConnectionInfo::MOMConnectionInfo(const MDAConnectionInfo& info)
    : m_info(info)
{
}

int MOMConnectionInfo::provisionedBandwidth() const
{
    return m_info.max_bandwidth;
}

int MOMConnectionInfo::channelBandwidth() const
{
    return m_info.chan_bandwidth;
}

int MOMConnectionInfo::totalBandwidth() const
{
    return m_info.total_bandwidth;
}

} // namespace WebCore

#endif // ENABLE(RMAI)
