/** @file MOMContentCatalogue.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMContentCatalogue_h
#define MOMContentCatalogue_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>
#include "MOMContentItem.h"
#include "MOMException.h"
#include "MOMStringCollection.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_content_catalogue.h"
}

namespace WebCore {

class MOMStringCollection;

class MOMContentCatalogue : public MOMContentItem {
public:

    MOMContentCatalogue(ScriptExecutionContext *context, mom_content_item item);

    MOMContentItem* rootFolder() const;
    MOMStringCollection* genres() const;

    PassRefPtr<MOMContentItem> createSearch();
    void signOn( ExceptionCode& ec );
    void signOn( const String & userId, ExceptionCode& ec );
    void signOff(ExceptionCode& ec);

    ALWAYS_INLINE mom_content_catalogue itemAsContentCatalogue() const { return (mom_content_catalogue)m_item; }

private:
    mutable RefPtr<MOMContentItem> m_rootFolder;
    mutable RefPtr<MOMStringCollection> m_genres;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMContentCatalogue_h
