/** @file MOMContentEvent.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMContentEvent_h
#define MOMContentEvent_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "MOMEvent.h"

namespace WebCore {

class MOMContentItem;

class MOMContentEvent : public MOMEvent {
public:
    enum {
        BROWSE = 0,
        MORE_INFO = 1,
        PURCHASE = 2,
        CANCEL = 3,
        SETBOOKMARK = 4,
        SIGNON = 5,
        SIGNOFF = 6,
        LIST_UPDATED = 7,
        NEXT_SHOWING = 8,
    };

    static PassRefPtr<MOMContentEvent> create()
    {
        return adoptRef(new MOMContentEvent);
    }

    int action() const { return getIntParam(mom_event_CONTENTACTION_ACTION); }
    int result() const { return getIntParam(mom_event_CONTENTACTION_RESULT); }
    MOMContentItem* item() const { return m_object.get(); }

    MOMContentEvent(const mom_event_params* params, ScriptExecutionContext* context);
private:
    MOMContentEvent();
    mutable RefPtr<MOMContentItem> m_object;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMContentEvent_h
