/** @file MOMContentList.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMContentList_h
#define MOMContentList_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>
#include "MOMContentItem.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_content_item.h"
}

namespace WebCore {

class MOMContentList : public MOMContentItem {
public:
    static PassRefPtr<MOMContentList> createAdopt(ScriptExecutionContext *context, mom_content_list list);
    static PassRefPtr<MOMContentList> create(ScriptExecutionContext *context, mom_content_list list);
    MOMContentList(ScriptExecutionContext *context, mom_content_item item);

    int length() const;

    PassRefPtr<MOMContentItem> item( int index );
    RefPtr<MOMContentItem> namedItem( const String & name );
    PassRefPtr<MOMContentItem> nextItem( MOMContentItem* item, bool wrap = false);
    PassRefPtr<MOMContentItem> prevItem( MOMContentItem* item, bool wrap = false);

    ALWAYS_INLINE mom_content_list itemAsContentList() const { return (mom_content_list)m_item; }
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMContentList_h
