/** @file MOMContentPagedList.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMContentPagedList_h
#define MOMContentPagedList_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "ExceptionCode.h"
#include "MOMContentList.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_content_paged_list.h"
}

namespace WebCore {

class MOMContentPagedList : public MOMContentList {
public:

    static PassRefPtr<MOMContentPagedList> createAdopt(ScriptExecutionContext *context, mom_content_paged_list list);
    MOMContentPagedList(ScriptExecutionContext *context, mom_content_item item);

    void getPage( int page, int pageSize, ExceptionCode& ec );
    void abort(ExceptionCode& ec);

    ALWAYS_INLINE mom_content_paged_list itemAsContentPagedList() const { return (mom_content_paged_list) m_item; }
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMContentPagedList_h
