/** @file MOMDRMMessageResultEvent.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMDRMMessageResultEvent_h
#define MOMDRMMessageResultEvent_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "MOMEvent.h"

namespace WebCore {

class MOMDRMMessageResultEvent : public MOMEvent {
public:
    enum {
        OK = 0,
        UNKNOWN_ERROR = 1,
        UNKNOWN_MIME_TYPE = 2,
        DATA_INVALID = 3,
        LICENCE_INVALID = 4,
        LICENCE_EXPIRED = 5,
    };

    static PassRefPtr<MOMDRMMessageResultEvent> create()
    {
        return adoptRef(new MOMDRMMessageResultEvent);
    }

    String msgID() const { return getStringParam(mom_event_DRM_MSGID_S); }
    String resultMsg() const { return getStringParam(mom_event_DRM_RESULTMSG_S); }
    int resultCode() const { return getIntParam(mom_event_DRM_RESULTCODE); }

    MOMDRMMessageResultEvent(const mom_event_params* params, ScriptExecutionContext* context);
private:
    MOMDRMMessageResultEvent();
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMDRMMessageResultEvent_h
