/** @file MOMDeviceEvent.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMDeviceEvent.h"

namespace WebCore {

MOMDeviceEvent::MOMDeviceEvent(const mom_event_params* params, ScriptExecutionContext* context)
    : MOMEvent(AtomicString("MOM_Device"), params)
{
    ASSERT(params->arg_count == mom_event_DEVICE_COUNT);
    m_object = params->object ? MOMDevice::create(context, static_cast<mom_driver>(params->object)) : nullptr;
}

MOMDeviceEvent::MOMDeviceEvent()
    : MOMEvent(AtomicString("MOM_Device"))
{
}

} // namespace WebCore

#endif // ENABLE(RMAI)
