/** @file MOMDiscEvent.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMDiscEvent_h
#define MOMDiscEvent_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "MOMEvent.h"

namespace WebCore {

class MOMDiscEvent : public MOMEvent {
public:
    static PassRefPtr<MOMDiscEvent> create()
    {
        return adoptRef(new MOMDiscEvent);
    }

    int state() const { return getIntParam(mom_event_DISC_STATE); }
    int progress() const { return getIntParam(mom_event_DISC_PROGRESS); }

    MOMDiscEvent(const mom_event_params* params, ScriptExecutionContext* context);
private:
    MOMDiscEvent();
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMDiscEvent_h
