/** @file MOMEASEvent.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMEASEvent_h
#define MOMEASEvent_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "MOMEvent.h"
#include "MOMStringCollection.h"

namespace WebCore {

class MOMEASEvent : public MOMEvent {
public:
    enum {
        SHOW = 0,
        SHOW_ONCE = 1,
        HIDE = 2,
    };

    static PassRefPtr<MOMEASEvent> create()
    {
        return adoptRef(new MOMEASEvent);
    }
    int reason() const { return getIntParam(mom_event_EAS_REASON); }
    int repeatDelay() const { return getIntParam(mom_event_EAS_REPEATDELAY); }
    int displaySize() const { return getIntParam(mom_event_EAS_DISPLAYSIZE); }
    int motionDelay() const { return getIntParam(mom_event_EAS_MOTIONDELAY); }
    int x0() const { return getIntParam(mom_event_EAS_WINX0); }
    int y0() const { return getIntParam(mom_event_EAS_WINY0); }
    int x1() const { return getIntParam(mom_event_EAS_WINX1); }
    int y1() const { return getIntParam(mom_event_EAS_WINY1); }
    MOMStringCollection* message() const { return m_object.get(); }

    MOMEASEvent(const mom_event_params* params, ScriptExecutionContext* context);
private:
    MOMEASEvent();
    mutable RefPtr<MOMStringCollection> m_object;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMEASEvent_h
