/** @file MOMGuideSearchEvent.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMGuideSearchEvent.h"

namespace WebCore {

MOMGuideSearchEvent::MOMGuideSearchEvent(const mom_event_params* params, ScriptExecutionContext* context)
    : MOMEvent(AtomicString("MOM_GuideSearch"), params)
{
    ASSERT(params->arg_count == mom_event_GUIDESEARCH_COUNT);
    m_object = params->object ? MOMContentItem::create(context, static_cast<mom_content_item>(params->object)) : nullptr;
}

MOMGuideSearchEvent::MOMGuideSearchEvent()
    : MOMEvent(AtomicString("MOM_GuideSearch"))
{
}

} // namespace WebCore

#endif // ENABLE(RMAI)
