/** @file MOMNetworkInterfaceCollection.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMNetworkInterfaceCollection_h
#define MOMNetworkInterfaceCollection_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

namespace WebCore {

class MOMNetworkInterface;
class ScriptExecutionContext;

class MOMNetworkInterfaceCollection : public RefCounted<MOMNetworkInterfaceCollection> {
public:

    static PassRefPtr<MOMNetworkInterfaceCollection> create(ScriptExecutionContext* context);

    int length() const;

    PassRefPtr<MOMNetworkInterface> item( int index );

protected:
    MOMNetworkInterfaceCollection(ScriptExecutionContext* context);

private:
    ScriptExecutionContext* m_context;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMNetworkInterfaceCollection_h
