/** @file MOMNetworkTestEvent.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMNetworkTestEvent_h
#define MOMNetworkTestEvent_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "MOMEvent.h"

namespace WebCore {

class MOMNetworkTestEvent : public MOMEvent {
public:
    static PassRefPtr<MOMNetworkTestEvent> create()
    {
        return adoptRef(new MOMNetworkTestEvent);
    }

    bool success() const { return getIntParam(mom_event_NETWORKTEST_SUCCESS); }
    int id() const { return getIntParam(mom_event_NETWORKTEST_ID); }

    MOMNetworkTestEvent(const mom_event_params* params, ScriptExecutionContext* context);
private:
    MOMNetworkTestEvent();
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMNetworkTestEvent_h
