/** @file MOMOutput.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMOutput_h
#define MOMOutput_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

namespace WebCore {

class MOMOutput : public RefCounted<MOMOutput> {
public:
    enum {
        UNKNOWN = 0,
        DISCONNECTED = 1,
        CONNECTED = 2,
    };

    static PassRefPtr<MOMOutput> create(int index);

    String name() const;
    String type() const;
    bool enable() const;
    void setEnable(bool enable);

    int connected() const;
    bool subtitleEnable() const;
    void setSubtitleEnable(bool subtitleEnable);

    String videoMode() const;
    void setVideoMode(const String & videoMode);

    String digitalAudioMode() const;
    void setDigitalAudioMode(const String & digitalAudioMode);

    String audioRange() const;
    void setAudioRange(const String & audioRange);

    String hdVideoFormat() const;
    void setHdVideoFormat(const String & hdVideoFormat);

    String hdVideoFormatsEnabled() const;
    void setHdVideoFormatsEnabled(const String & hdVideoFormatsEnabled);

    String tvAspectRatio() const;
    void setTvAspectRatio(const String & tvAspectRatio);

    String ccAnalogueService() const;
    void setCcAnalogueService(const String & ccAnalogueService);

    String ccDigitalService() const;
    void setCcDigitalService(const String & ccDigitalService);

    String ccBackgroundStyle() const;
    void setCcBackgroundStyle(const String & ccBackgroundStyle);

    String ccBackgroundColour() const;
    void setCcBackgroundColour(const String & ccBackgroundColour);

    String ccCharacterColour() const;
    void setCcCharacterColour(const String & ccCharacterColour);

    String ccCharacterSize() const;
    void setCcCharacterSize(const String & ccCharacterSize);

    String ccCharacterEdge() const;
    void setCcCharacterEdge(const String & ccCharacterEdge);

    String ccCharacterFont() const;
    void setCcCharacterFont(const String & ccCharacterFont);

    String ccWindowColor() const;
    void setCcWindowColor(const String & ccWindowColor);

    String ccWindowStyle() const;
    void setCcWindowStyle(const String & ccWindowStyle);

    String ccCharacterStyle() const;
    void setCcCharacterStyle(const String & ccCharacterStyle);

    bool ccStyleSetByProgramme() const;
    void setCcStyleSetByProgramme(bool ccStyleSetByProgramme);

protected:
    MOMOutput(int index);

private:
    int m_index;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMOutput_h
