/** @file MOMPackageEvent.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMPackageEvent.h"

namespace WebCore {

MOMPackageEvent::MOMPackageEvent(const mom_event_params* params, ScriptExecutionContext* context)
    : MOMEvent(AtomicString("MOM_Package"), params)
{
    ASSERT(params->arg_count == mom_event_PACKAGE_COUNT);
    m_object = params->object ? MOMContentItem::create(context, static_cast<mom_content_item>(params->object)) : nullptr;
}

MOMPackageEvent::MOMPackageEvent()
    : MOMEvent(AtomicString("MOM_Package"))
{
}

} // namespace WebCore

#endif // ENABLE(RMAI)
