/** @file MOMPackageList.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMPackageList_h
#define MOMPackageList_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>
#include "MOMContentList.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_package_list.h"
}

namespace WebCore {

class MOMPackageList : public MOMContentList {
public:

    static PassRefPtr<MOMPackageList> create(ScriptExecutionContext *context, mom_package_list list);
    static PassRefPtr<MOMPackageList> createAdopt(ScriptExecutionContext *context, mom_package_list list);
    MOMPackageList(ScriptExecutionContext *context, mom_content_item item);
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMPackageList_h
