/** @file MOMParentalRating.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMParentalRating.h"
#include "MOMParentalRatingScheme.h"

#include "UtilsMOM.h"

namespace WebCore {

PassRefPtr<MOMParentalRating> MOMParentalRating::create(mom_content_item item)
{
    return adoptRef(new MOMParentalRating(item));
}

MOMParentalRating::MOMParentalRating(mom_content_item item)
{
    m_item = mom_content_item_keep(item);
}

MOMParentalRating::~MOMParentalRating()
{
    mom_content_item_dispose(m_item);
    m_item = NULL;
}

MOMParentalRatingScheme* MOMParentalRating::scheme() const
{
    if (!m_scheme)
        m_scheme = MOMParentalRatingScheme::create(mom_content_item_get_parental_rating_scheme(m_item));
    return m_scheme.get();
}

int MOMParentalRating::value() const
{
    return mom_content_item_get_parental_rating(m_item);
}

int MOMParentalRating::labels() const
{
    // not implemented in Galio
    return 0;
}

String MOMParentalRating::toString()
{
    return UtilsMOM::StringFromLayersString(mom_content_item_get_parental_rating_string(m_item));
}

} // namespace WebCore

#endif // ENABLE(RMAI)
