/** @file MOMParentalRatingScheme.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMParentalRatingScheme.h"
#include "UtilsMOM.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_parentalcontrols.h"
}

namespace WebCore {

PassRefPtr<MOMParentalRatingScheme> MOMParentalRatingScheme::create(mom_parentalrating_scheme scheme)
{
    return adoptRef(new MOMParentalRatingScheme(scheme));
}

MOMParentalRatingScheme::MOMParentalRatingScheme(mom_parentalrating_scheme scheme)
{
    m_scheme = scheme;
}

int MOMParentalRatingScheme::threshold() const
{
    return mom_parentalcontrols_scheme_get_threshold(m_scheme);
}

void MOMParentalRatingScheme::setThreshold(int threshold)
{
    mom_parentalcontrols_scheme_set_threshold(m_scheme, threshold);
}

int MOMParentalRatingScheme::length() const
{
    return mom_parentalcontrols_scheme_ratings_count(m_scheme);
}

String MOMParentalRatingScheme::title() const
{
    return UtilsMOM::StringFromLayersString(mom_parentalcontrols_scheme_get_title(m_scheme));
}

String MOMParentalRatingScheme::item( int index )
{
    return UtilsMOM::StringFromLayersString(mom_parentalcontrols_scheme_get_rating(m_scheme, index));
}

} // namespace WebCore

#endif // ENABLE(RMAI)
