/** @file MOMParentalRatingScheme.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMParentalRatingScheme_h
#define MOMParentalRatingScheme_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

extern "C" {
#include "layers.h"
#include "cdf/mom_parentalcontrols.h"
}

namespace WebCore {

class MOMParentalRatingScheme : public RefCounted<MOMParentalRatingScheme> {
public:

    static PassRefPtr<MOMParentalRatingScheme> create(mom_parentalrating_scheme scheme);

    int threshold() const;
    void setThreshold(int threshold);

    int length() const;
    String title() const;

    String item( int index );

protected:
    MOMParentalRatingScheme(mom_parentalrating_scheme scheme);

private:
    mom_parentalrating_scheme m_scheme;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMParentalRatingScheme_h
