/** @file MOMPlayEvent.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMPlayEvent.h"
#include "UtilsMOM.h"
#include "MOMException.h"
#include "EventNames.h"

namespace WebCore {

MOMPlayEvent::MOMPlayEvent(const mom_event_params* params, ScriptExecutionContext* context)
    : MOMEvent(AtomicString("MOM_Play"), params)
{
    ASSERT(params->arg_count == mom_event_PLAY_COUNT);
    setIntParam(mom_event_PLAY_STATE, UtilsMOM::codeFromStreamState( params->args[mom_event_PLAY_STATE] ));
    setIntParam(mom_event_PLAY_CONDITION, MOMException::codeFromMOMError( params->args[mom_event_PLAY_CONDITION] ));
    m_object = params->object ? MOMContentItem::create(context, static_cast<mom_content_item>(params->object)) : nullptr;
}

MOMPlayEvent::MOMPlayEvent()
    : MOMEvent(AtomicString("MOM_Play"))
{
}

} // namespace WebCore

#endif // ENABLE(RMAI)
