/** @file MOMPurchasableContentCatalogue.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMPurchasableContentCatalogue.h"
#include "MOMContentItem.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_purchasable_content_catalogue.h"
}

namespace WebCore {

MOMPurchasableContentCatalogue::MOMPurchasableContentCatalogue(ScriptExecutionContext *context, mom_content_item item)
    : MOMContentCatalogue(context, item)
{
}

PassRefPtr<MOMContentItem> MOMPurchasableContentCatalogue::getPurchaseHistory()
{
    mom_purchasable_content_catalogue catalogue = (mom_purchasable_content_catalogue)itemAsItem();
    return MOMContentItem::createAdopt(scriptExecutionContext(), (mom_content_item)mom_purchasable_content_catalogue_get_purchase_history(catalogue));
}

PassRefPtr<MOMContentItem> MOMPurchasableContentCatalogue::getActivePurchases()
{
    mom_purchasable_content_catalogue catalogue = (mom_purchasable_content_catalogue)itemAsItem();
    return MOMContentItem::createAdopt(scriptExecutionContext(), (mom_content_item)mom_purchasable_content_catalogue_get_active_purchases(catalogue));
}

} // namespace WebCore

#endif // ENABLE(RMAI)
