/** @file MOMPurchaseEvent.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMPurchaseEvent_h
#define MOMPurchaseEvent_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "MOMEvent.h"

namespace WebCore {

class MOMPurchaseEvent : public MOMEvent {
public:
    enum {
        MODIFIED = 0,
        DELETED = 1,
        SCHEDULE_STARTED = 2,
        SCHEDULE_ENDED = 3,
        PREVIEW_WINDOW_STARTED = 4,
        PREVIEW_WINDOW_ENDED = 5,
        PURCHASE_WINDOW_ENDED = 6,
        ADVERTISING_WINDOW_STARTED = 7,
        ADVERTISING_WINDOW_ENDED = 8,
        CANCEL_WINDOW_ENDED = 9,
    };

    static PassRefPtr<MOMPurchaseEvent> create()
    {
        return adoptRef(new MOMPurchaseEvent);
    }
    
    int action() const { return getIntParam(mom_event_PURCHASE_ACTION); }

    MOMPurchaseEvent(const mom_event_params* params, ScriptExecutionContext* context);
private:
    MOMPurchaseEvent();
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMPurchaseEvent_h
