/** @file MOMRecordEvent.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMRecordEvent.h"

#include "UtilsMOM.h"

namespace WebCore {

MOMRecordEvent::MOMRecordEvent(const mom_event_params* params, ScriptExecutionContext*)
    : MOMEvent(AtomicString("MOM_Record"), params)
{
    ASSERT(params->arg_count == mom_event_RECORD_COUNT);
    setIntParam(mom_event_RECORD_STATE, UtilsMOM::codeFromStreamState( params->args[mom_event_RECORD_STATE] ));
}

MOMRecordEvent::MOMRecordEvent()
    : MOMEvent(AtomicString("MOM_Record"))
{
}

} // namespace WebCore

#endif // ENABLE(RMAI)
