/** @file MOMRequestEvent.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMRequestEvent.h"

namespace WebCore {

MOMRequestEvent::MOMRequestEvent(const mom_event_params* params, ScriptExecutionContext* context)
    : MOMEvent(AtomicString("MOM_Request"), params)
{
    ASSERT(params->arg_count == mom_event_REQUEST_COUNT);
    m_object = params->object ? MOMContentItem::create(context, static_cast<mom_content_item>(params->object)) : nullptr;
}

MOMRequestEvent::MOMRequestEvent()
    : MOMEvent(AtomicString("MOM_Request"))
{
}

} // namespace WebCore

#endif // ENABLE(RMAI)
