/** @file MOMRequestEvent.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMRequestEvent_h
#define MOMRequestEvent_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "MOMEvent.h"

namespace WebCore {

class MOMContentItem;

class MOMRequestEvent : public MOMEvent {
public:
    enum {
        PLAY = 1,
        DOWNLOAD_IMAGE = 2,
    };
    static PassRefPtr<MOMRequestEvent> create()
    {
        return adoptRef(new MOMRequestEvent);
    }
    
    int reason() const { return getIntParam(mom_event_REQUEST_REASON); }
    int offset() const { return getIntParam(mom_event_REQUEST_OFFSET); }
    int urgency() const { return getIntParam(mom_event_REQUEST_URGENCY); }
    MOMContentItem* object() const { return m_object.get(); }

    MOMRequestEvent(const mom_event_params* params, ScriptExecutionContext* context);
private:
    MOMRequestEvent();
    mutable RefPtr<MOMContentItem> m_object;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMRequestEvent_h
