/** @file MOMResourceConflictEvent.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMResourceConflictEvent.h"

namespace WebCore {

MOMResourceConflictEvent::MOMResourceConflictEvent(const mom_event_params* params, ScriptExecutionContext* context)
    : MOMEvent(AtomicString("MOM_ResourceConflict"), params)
{
    ASSERT(params->arg_count == mom_event_RESOURCECONFLICT_COUNT);
    m_object = params->object ? MOMContentItem::create(context, static_cast<mom_content_item>(params->object)) : nullptr;
}

MOMResourceConflictEvent::MOMResourceConflictEvent()
    : MOMEvent(AtomicString("MOM_ResourceConflict"))
{
}

} // namespace WebCore

#endif // ENABLE(RMAI)
