/** @file MOMSource.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMSource.h"

extern "C" {
#include "layers.h"
}

namespace WebCore {

PassRefPtr<MOMSource> MOMSource::create(ScriptExecutionContext* context, mom_driver driver)
{
    return adoptRef(new MOMSource(context, driver));
}

MOMSource::MOMSource(ScriptExecutionContext* context, mom_driver driver)
    : MOMDevice(context, driver)
{
}

int MOMSource::sourceType() const
{
    int num;

    switch ( mom_driver_sub_type( driver() ) )
    {
    case MDA_SUBTYPE_DVBT:
    case MDA_SUBTYPE_DVBS:
    case MDA_SUBTYPE_DVBC:
    case MDA_SUBTYPE_OPENCABLE:
    case MDA_SUBTYPE_ATSC:
        num = MOM::RF;
        break;
    case MDA_SUBTYPE_IPTV:
        num = MOM::IPTV;
        break;
    case MDA_SUBTYPE_UPNP:
        num = MOM::UPNP;
        break;
    case MDA_SUBTYPE_VOD:
        num = MOM::VOD;
        break;
    default:
        num = MOM::NONE;
        break;
    }

    return num;
}

} // namespace WebCore

#endif // ENABLE(RMAI)
