/** @file MOMSource.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMSource_h
#define MOMSource_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

#include "MOMDevice.h"
#include "MOM.h"

namespace WebCore {

class MOMSource : public MOMDevice {
public:

    static PassRefPtr<MOMSource> create(ScriptExecutionContext* context, mom_driver driver);

    int deviceType() const { return MOM::SOURCE; }
    int sourceType() const;

protected:
    MOMSource(ScriptExecutionContext* context, mom_driver driver);
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMSource_h
