/** @file MOMStringCollection.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMStringCollection_h
#define MOMStringCollection_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>

extern "C" {
#include "layers.h"
#include "cdf/mom_urilist.h"
}

namespace WebCore {

class MOMStringCollection : public RefCounted<MOMStringCollection> {
public:

    static PassRefPtr<MOMStringCollection> createAdopt(mom_urilist strings);
    static PassRefPtr<MOMStringCollection> create(mom_urilist strings);
    ~MOMStringCollection();

    int length() const;

    String item( int index );
    String namedItem( const String & name );
    String join( const String & sep );
    String toString();

protected:
    MOMStringCollection(mom_urilist strings);

private:
    mom_urilist m_strings;
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMStringCollection_h
