/** @file MOMUpdateEvent.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMUpdateEvent.h"

namespace WebCore {

MOMUpdateEvent::MOMUpdateEvent(const mom_event_params* params, ScriptExecutionContext* context)
    : MOMEvent(AtomicString("MOM_Update"), params)
{
    ASSERT(params->arg_count == mom_event_UPDATE_COUNT);
    m_object = params->object ? MOMContentItem::create(context, static_cast<mom_content_item>(params->object)) : nullptr;
}

MOMUpdateEvent::MOMUpdateEvent()
    : MOMEvent(AtomicString("MOM_Update"))
{
}

} // namespace WebCore

#endif // ENABLE(RMAI)
