/** @file MOMVODCatalogue.cpp
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#include "config.h"

#if ENABLE(RMAI)

#include "MOMVODCatalogue.h"
#include "MOMContentItem.h"
#include "MOMContentPagedList.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_vod_catalogue.h"
}

namespace WebCore {

MOMVODCatalogue::MOMVODCatalogue(ScriptExecutionContext *context, mom_content_item item)
    : MOMContentCatalogue(context, item)
{
}

PassRefPtr<MOMContentItem> MOMVODCatalogue::getPurchaseHistory()
{
    mom_content_paged_list list = mom_vod_catalogue_get_purchase_history(itemAsVODCatalogue());
    return list ? MOMContentPagedList::createAdopt(scriptExecutionContext(), list) : nullptr;
}

PassRefPtr<MOMContentItem> MOMVODCatalogue::getActiveRentals()
{
    mom_content_paged_list list = mom_vod_catalogue_get_active_rentals(itemAsVODCatalogue());
    return list ? MOMContentPagedList::createAdopt(scriptExecutionContext(), list) : nullptr;
}

PassRefPtr<MOMContentItem> MOMVODCatalogue::getExpired( int since )
{
    mom_content_paged_list list = mom_vod_catalogue_get_expired(itemAsVODCatalogue(), since);
    return list ? MOMContentPagedList::createAdopt(scriptExecutionContext(), list) : nullptr;
    return nullptr;
}

PassRefPtr<MOMContentItem> MOMVODCatalogue::getExpired()
{
	return getExpired(0);
}

PassRefPtr<MOMContentItem> MOMVODCatalogue::getAvailableServices()
{
    mom_content_paged_list list = mom_vod_catalogue_get_available_services(itemAsVODCatalogue());
    return list ? MOMContentPagedList::createAdopt(scriptExecutionContext(), list) : nullptr;
}

} // namespace WebCore

#endif // ENABLE(RMAI)
