/** @file MOMVODCatalogue.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMVODCatalogue_h
#define MOMVODCatalogue_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>
#include "MOMContentCatalogue.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_vod_catalogue.h"
}

namespace WebCore {

class MOMContentItem;

class MOMVODCatalogue : public MOMContentCatalogue {
public:

    MOMVODCatalogue(ScriptExecutionContext *context, mom_content_item item);

    PassRefPtr<MOMContentItem> getPurchaseHistory();
    PassRefPtr<MOMContentItem> getActiveRentals();
    PassRefPtr<MOMContentItem> getExpired();
    PassRefPtr<MOMContentItem> getExpired( int since );
    PassRefPtr<MOMContentItem> getAvailableServices();

    ALWAYS_INLINE mom_vod_catalogue itemAsVODCatalogue() const { return (mom_vod_catalogue) m_item; }
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMVODCatalogue_h
