/** @file MOMVODService.h
 *
 * Copyright (C) Espial Limited 2014 - Company confidential - All rights reserved.
 *
 */

#ifndef MOMVODService_h
#define MOMVODService_h

#if ENABLE(RMAI)

#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/text/AtomicString.h>
#include "MOMContentPagedList.h"

extern "C" {
#include "layers.h"
#include "cdf/mom_vod_service.h"
}

namespace WebCore {

class MOMPlayer;
class MOMStringCollection;


class MOMVODService : public MOMContentPagedList {
public:
    MOMVODService(ScriptExecutionContext *context, mom_content_item item);

    bool isBrowsable() const;

    void connect( MOMPlayer* player, ExceptionCode& ec );
    void connect( MOMPlayer* player, int mode, ExceptionCode& ec );
    int purchase( const String & pin, ExceptionCode& ec );
    void cancel(ExceptionCode& ec);
    MOMStringCollection* lookupMetadata( const String & key );

    ALWAYS_INLINE mom_vod_service itemAsVODService() const { return (mom_vod_service)m_item; }
};

} // namespace WebCore

#endif // ENABLE(RMAI)

#endif // MOMVODService_h
