/*
 * Copyright (C) 2012 Samsung Electronics
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

/**
 * @file    EWebKit2.h
 * @brief   Contains the header files that are required by WebKit2-EFL.
 *
 * It includes the all header files that are exported to public API.
 */

#ifndef EWebKit2_h
#define EWebKit2_h

#include "ewk_context.h"
#include "ewk_cookie_manager.h"
#include "ewk_intent.h"
#include "ewk_intent_service.h"
#include "ewk_main.h"
#include "ewk_navigation_policy_decision.h"
#include "ewk_url_request.h"
#include "ewk_url_response.h"
#include "ewk_url_scheme_request.h"
#include "ewk_view.h"
#include "ewk_web_error.h"
#include "ewk_web_resource.h"

#endif // EWebKit2_h
